# -*- coding: utf-8 -*-
##############################################################################
#	(c)2023 by Oberhesse (contact: vuplus-support.org)
#	FREE FOR PERSONAL USE
#	CLOSED SOURCE - VTI ONLY
# 	DO NOT PUBLISH ON GITHUB
##############################################################################

from Components.Language import language
from Tools.Directories import resolveFilename, SCOPE_PLUGINS, SCOPE_LANGUAGE
from enigma import getDesktop
import gettext


def localeInit():
	lang = language.getLanguage()
	try: os.environ["LANGUAGE"] = lang[:2]
	except: pass
	gettext.bindtextdomain("enigma2", resolveFilename(SCOPE_LANGUAGE))
	gettext.textdomain("enigma2")
	gettext.bindtextdomain("FCCExtender", "%s%s" % (resolveFilename(SCOPE_PLUGINS), "Extensions/FCCExtender/locale/"))


def _(txt, germanTxt=''):
	t = gettext.dgettext("FCCExtender", txt)
	if t == txt:  t = gettext.gettext(txt)
	if (t == txt) and germanTxt:
		try: 
			from Components.config import config
			if str(config.osd.language.value).lower().startswith('de'):  t = germanTxt
		except: pass
	return t

try:  localeInit();  language.addCallback(localeInit)
except: pass

##############################################################################

try: scale = getDesktop(0).size().width()/1280.0 
except: scale = 1.0

def scaled(i): return int (round(i*scale))

def iconFile(): 
	return 'FCCExtender.png' if scale<=1 else 'FCCExtenderFHD.png'

def scaledSkin (skin):
	def scaleVal(s):
		try: return scaled(int(s)) 
		except: return 0	
	def sPos (s, text): i = text.find(s);   return [ i, 999999 ][ (i<0) or (s=='') ] 
	def firstElemInText ( elem1, elem2, elem3, text ):
		i = min( sPos(elem1, text), sPos(elem2, text), sPos(elem3, text) )
		return [ i, -1 ][ i==999999 ]
	res = ''
	while len(skin):
		i = firstElemInText ( '"_' , ',_', ';_' , skin )
		if (i<0): return res + skin
		res += skin [ :(i+1)];  skin = skin [ (i+2): ];  i = firstElemInText (  '"' , ',' , '', skin )
		if i < 0: return res + skin
		res += str( scaleVal(skin[ :i ]));  skin = skin [ i: ]
	return res + skin


	
	