# -*- coding: utf-8 -*-
##############################################################################
#	(c)2023 by Oberhesse (contact: vuplus-support.org)
#	FREE FOR PERSONAL USE
#	CLOSED SOURCE
# 	DO NOT PUBLISH ON GITHUB
##############################################################################

from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen
from Components.ActionMap import ActionMap
from Components.ConfigList import ConfigListScreen
from Components.config import config, getConfigListEntry, ConfigSelection, ConfigSubsection, ConfigYesNo
from .__init__ import _, scaledSkin

##############################################################################

pname = "FCC Extender"
pversion = '0.3 Beta'
pdesc = 'Extended Fast Channel Change'
pdate= '2023-11-05'
	
##############################################################################
	
config.plugins.FCCExtender = ConfigSubsection()
config.plugins.FCCExtender.active = ConfigYesNo(default=False)
config.plugins.FCCExtender.delay = ConfigSelection (default="250", 
	choices = [ ("100", "100ms" ), ( "250", "250ms" ), ("500", "500ms" ), ("1000", "1000ms") ] )

class FCCExtenderSettings (Screen, ConfigListScreen):
	skin = """<screen name="FCCExtenderSettings" position="center,center" size="_690,_140" title="#title#" >
	<widget name="config" font="Regular;_24"  position="_20,_20" size="_650,_80" itemHeight="_40" />
	<eLabel text="#version#" font="Regular;_15" position="_20,_107" size="_650,_30" halign="right" valign="top"  transparent="1" />
	</screen>"""
	def __init__(self, session, args = 0):
		self.session = session;  Screen.__init__(self, session)
		self.list = [];  ConfigListScreen.__init__(self, self.list, session = self.session )
		self["actions"] = ActionMap(  ["OkCancelActions"], {"cancel":self.doFinish}, -1)
		self.skin = scaledSkin(self.skin).replace( '#title#' , pname+' ('+_('Settings')+')' )
		self.skin = self.skin.replace( '#version#' , 'Version '+pversion+'  -  © 2023 OH')
		self.list.append( getConfigListEntry (pname+' '+_('Active', 'Aktiv'),  config.plugins.FCCExtender.active ) )
		self.list.append( getConfigListEntry (pname+' '+_('Delay for Channelselection', 'Verzögerung in Kanalliste'),  config.plugins.FCCExtender.delay ) )
					
	def doFinish(self, answer=None):  
		self.saveAll()
		run()
		self.close()

##############################################################################

def run():
	try:
		from .FCCExtender import init
		init()
	except: pass
		

def sessionstart(reason, **kwargs):  
	if reason == 0:  run()
		
def main (session, **kwargs): 
	session.open(FCCExtenderSettings)
	

def Plugins(**kwargs):
	desc = _( pdesc, 'Erweiterter schneller Kanalwechsel' )
	return [	PluginDescriptor(
				name =  _("FCC Extender"), 
				description = desc,  
				where = PluginDescriptor.WHERE_PLUGINMENU,
				icon = 'FCCExtender.png', 
				needsRestart = True, 
				fnc = main ),
			PluginDescriptor( 
				name = "FCC Extender", 
				where = PluginDescriptor.WHERE_SESSIONSTART,  
				fnc = sessionstart) 
			]
				
	

		